module SrcLoc where

data SrcLoc = SrcLoc {
	line :: Int,
	char :: Int
	}
	deriving (Eq)

instance Show SrcLoc where
	show (SrcLoc i j) = "(" ++ show i ++ "," ++ show j ++ ")"

shift :: SrcLoc -> Int -> SrcLoc
shift loc nbChars = loc {
	char = char loc + nbChars
	}


instance Ord SrcLoc where
	(SrcLoc i j) < (SrcLoc i' j') = i < i' || (i == i' && j < j')
